jQuery(function ($) {
	var loading = false;
	var inputString = 'https://www.youtube.com/playlist?list=PLDayGXtbQ4B1uuL3V2_R1lS_hcgeDTsNe'.replace(/&quot;/ig, ' ');
	var apiKeys=['AIzaSyC7Sxnjmy-557cICuoyFtLf1rXl5wWH4Uc',
		'AIzaSyC7Sxnjmy-557cICuoyFtLf1rXl5wWH4Uc',
		'AIzaSyAvjsAmcLANJSnm3sNfOJya-YH4_a1V0CQ',
		'AIzaSyA5vtGnh94IspnpqlB6Rn7_vOX3eu3BJRA',
		'AIzaSyCPwD_Y7FiQno4dbw_f-nNaHHVqGYLjhpU'];

	var apiKey= apiKeys[Math.floor(Math.random()*apiKeys.length)];


	function truncate(str, maxlength, end) {
		end = end == undefined ? '<a href="javascript:void(0)">...</a>' : end;
		if (str.length > maxlength) {
			return str.slice(0, maxlength - 3) + end;
		}
		return str;
	}

	function getDataByString(arr, str) {
		var keys = str.split('.');
		var tmp;
		tmp = arr;
		for (var i = 0; i < keys.length; i++) {
			if (tmp[keys[i]] == undefined) {
				return '';
			}
			else {
				tmp = tmp[keys[i]];
			}
		}
		return tmp;
	}


	function getPlaylistIdForUploads (channel,startIndex){

		$.get(
			'https://www.googleapis.com/youtube/v3/channels', {
				part:'contentDetails',
				forUsername: encodeURIComponent(channel),
				key: apiKey},
			function(data){
				$.each(data.items, function(i, item){
					var pid=item.contentDetails.relatedPlaylists.uploads;
					loadVideosFromUploaded(pid,startIndex);
				})
			}
		);
	}

	function loadVideosFromUploaded(pid,startIndex){
		var token=$('#temp').html();
		$.get(
			'https://www.googleapis.com/youtube/v3/playlistItems', {
				part:'snippet',
				maxResults:10,
				pageToken:token,
				playlistId:pid,
				key: apiKey},
			function(data){
				loading=false;
				if(!data.nextPageToken){
					var html = '';
					$.each(data.items, function(i, item){
						var item_template =
							'<a href="https://m.youtube.com/watch?v='+item.snippet.resourceId.videoId+'" class="collection-item" >' +
							'<img class="thumb" src="'+item.snippet.thumbnails.default.url+'">' +
							'<span class="title">'+item.snippet.title+'</span></a>';
						html += item_template;

					});
					$(".videos-collection").append(html);
					loading=false;
					$('.loader').hide();

				}else{
					token=data.nextPageToken;
					$('#temp').html(token);
					var html = '';
					$.each(data.items, function(i, item){
						var item_template =
							'<a href="https://m.youtube.com/watch?v='+item.snippet.resourceId.videoId+'" class="collection-item" >' +
							'<img class="thumb" src="'+item.snippet.thumbnails.default.url+'">' +
							'<span class="title">'+item.snippet.title+'</span></a>';
						html += item_template;

					});
					if(token == ''){
						$(".videos-collection").html(html);
					} else {
						$(".videos-collection").append(html);
					}
					loading=true;

				}
			}
		);
	}

	function loadFromChannel(startIndex){
		var channel = inputString
			.replace(/(.*?)\?.*/, '$1')
			.replace(/.*\/user\/(.*?)/, '$1')
			.replace(/(.*?)\/.*/, '$1');
		getPlaylistIdForUploads (channel,startIndex);
	}



	function loadFromPlaylist(startIndex){
		var playlistId=inputString.replace(/(.*?)\list=/,'');
		var token=$('#temp').html();
		$.get(
			'https://www.googleapis.com/youtube/v3/playlistItems', {
				part:'snippet',
				playlistId:playlistId,
				maxResults:10,
				pageToken:token,
				key: apiKey},
			function(data){
				loading=false;
				if(!data.nextPageToken){
					var html = '';
					$.each(data.items, function(i, item){
						var item_template =
							'<a href="https://m.youtube.com/watch?v='+item.snippet.resourceId.videoId+'" class="collection-item" >' +
							'<img class="thumb" src="'+item.snippet.thumbnails.default.url+'">' +
							'<span class="title">'+item.snippet.title+'</span></a>';
						html += item_template;

					});
					$(".videos-collection").append(html);
					loading=false;
					$('.loader').hide();
				}else{
					token=data.nextPageToken;
					$('#temp').html(token);
					var html = '';
					$.each(data.items, function(i, item){
						var item_template =
							'<a href="https://m.youtube.com/watch?v='+item.snippet.resourceId.videoId+'" class="collection-item" >' +
							'<img class="thumb" src="'+item.snippet.thumbnails.default.url+'">' +
							'<span class="title">'+item.snippet.title+'</span></a>';
						html += item_template;

					});
					if(token == ''){
						$(".videos-collection").html(html);
					} else {
						$(".videos-collection").append(html);
					}
					loading=true;


				}
			}
		);

	}

	function loadFromKeywords(url){
		var token=$('#temp').html();
		$.get(
			'https://www.googleapis.com/youtube/v3/search', {
				part:'snippet',
				q:encodeURIComponent(inputString),
				maxResults:10,
				pageToken:token,
				type:'video',
				key: apiKey},
			function(data){
				loading=false;
				if(!data.nextPageToken){
					var html = '';
					$.each(data.items, function(i, item){
						var item_template =
							'<a href="https://m.youtube.com/watch?v='+item.id.videoId+'" class="collection-item" >' +
							'<img class="thumb" src="'+item.snippet.thumbnails.default.url+'">' +
							'<span class="title">'+item.snippet.title+'</span></a>';
						html += item_template;

					});

					$(".videos-collection").append(html);
					$('.loader').hide();
					loading=false;

				}else{
					token=data.nextPageToken;
					$('#temp').html(token);
					var html = '';
					$.each(data.items, function(i, item){
						var item_template =
							'<a href="https://m.youtube.com/watch?v='+item.id.videoId+'" class="collection-item" >' +
							'<img class="thumb" src="'+item.snippet.thumbnails.default.url+'">' +
							'<span class="title">'+item.snippet.title+'</span></a>';
						html += item_template;

					});
					if(token == ''){
						$(".videos-collection").html(html);
					} else {
						$(".videos-collection").append(html);
					}
					loading=true;


				}
			}
		);
	}

	function loadVideos(startIndex) {
		if(!startIndex) startIndex = 1;
		if (/\/user\/(.*?)(\?.*)?.*/.test(inputString)) {
			loadFromChannel(startIndex);
		} else if (/playlist.*?\?.*?list=([A-Za-z0-9_]+(&|$))/i.test(inputString)) {
			loadFromPlaylist(startIndex);
		} else {
			loadFromKeywords(startIndex);
		}
	}

	loadVideos();

	$('#refresh-videos').click(function (e) {
		loadVideos();
	});

	$(window).scroll(function() {
		if($(window).scrollTop() + $(window).height() > $(document).height() - 100) {
			if(loading==true){
				loading=false;
				loadVideos($('.videos-collection .collection-item').length + 1);
			}
		}
	});
});